## cross-toolchain-base 17ubuntu1

=== debian/changelog ===
cross-toolchain-base (17ubuntu1) zesty; urgency=medium

  * Merge with Debian; remaining changes:
    - Don't build packages for mips, mipsel and mips64el.
    - Build using linux 4.8.
  * Build using linux 4.10.
  * Build using binutils 2.28.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 21 Mar 2017 15:39:14 +0100

cross-toolchain-base (17) unstable; urgency=medium

  * Build using linux 4.9.13.

 -- Matthias Klose <doko@debian.org>  Wed, 01 Mar 2017 18:07:10 +0100

cross-toolchain-base (16) unstable; urgency=medium

  * Build using linux 4.9.10.

 -- Matthias Klose <doko@debian.org>  Thu, 23 Feb 2017 16:35:10 +0100
