=== debian/rules ===
#!/usr/bin/make -f

# prefix for builds - without leading slash
PF ?= usr

include debian/kernelarch.make

vendor := $(shell if dpkg-vendor --derives-from Ubuntu; then echo Ubuntu; else echo Debian; fi)

# Support multiple makes at once based on number of processors
COMMA = ,
# Support parallel=<n> in DEB_BUILD_OPTIONS (see #209008)
ifneq (,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
  NUMCPUS := $(subst parallel=,,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
  NJOBS := -j $(NUMCPUS)
  DH_PARALLEL := parallel=$(NUMCPUS)
endif

DEB_NAME_ACT     := $(shell dpkg-parsechangelog| sed -n 's/-*//; s/^Source: \(.*\)/\1/p')
DEB_SVER_ACT     := $(shell dpkg-parsechangelog| sed -n 's/^Version: \(.*\)/\1/p')
DEB_VER_ACT      := $(shell /bin/sh debian/new_cross_version.sh $(if $(filter $(DEB_NAME_ACT), cross-toolchain-base),ppc64el,ppc64))
CROSS_EXT	:= cross$(DEB_VER_ACT)

HOST_ARCH        := $(shell dpkg-architecture -qDEB_HOST_ARCH_CPU)
HOST_GNU_TYPE    := $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
BUILD_GNU_TYPE   := $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
stamp            := stamp-dir/

ifeq ($(vendor),Debian)
  skip_dbg_packages = yes
endif

ifeq ($(DEB_NAME_ACT),cross-toolchain-base)
  CROSS_ARCHS	?= s390x ppc64el arm64 armhf armel \
			$(if $(filter $(vendor), Ubuntu),, mips mipsel mips64el)
else
  CROSS_ARCHS  ?= alpha hppa m68k mips64 powerpc ppc64 sh4 sparc64 \
			$(if $(filter $(vendor), Ubuntu), mips mipsel mips64el) \
			powerpcspe
endif
CROSS_ARCH       = $(subst .,,$(suffix $@))
KERNEL_ARCH      = $(KERNEL_ARCH_$(CROSS_ARCH))
CROSS_BIARCH     = $(CROSS_BIARCH_$(CROSS_ARCH))
_gnu_type        = $(shell dpkg-architecture -a$(1) -qDEB_HOST_GNU_TYPE -f)
CROSS_GNU_TYPE   = $(call _gnu_type,${CROSS_ARCH})

# ARM32 soft-float/hard-float multilibs. These are not yet built in a
# "proper" multilib location, so only build simple dependency packages
ARM32_MULTILIBS :=
ifeq ($(vendor),Ubuntu)
  ARM32_MULTILIBS := yes
  ARM32_MULTILIBS := dummy
endif

MIN_VER_GLIBC		:= 2.24-8~
MIN_VER_LINUX		:= 4.10
MIN_VER_GCC		:= 6.3.0-3~
MIN_VER_BINUTILS	:= 2.28-1~

DEB_VER_LINUX  := $(shell apt-cache policy linux-libc-dev | awk '/^ \*\*\*/ {print $$2}')
ifeq ($(vendor),Ubuntu)
  VER_LINUX      := $(shell echo $(DEB_VER_LINUX) | sed 's/^\([0-9]*\.[0-9]*\.[0-9]*\).*/\1/')
else
  VER_LINUX      := $(shell echo $(DEB_VER_LINUX) | sed 's/^\([0-9]*\.[0-9]*\).*/\1/')
endif
VER_GCC_BASE   := 6

VER_GCC          := $(shell dpkg-parsechangelog -l/usr/src/gcc-${VER_GCC_BASE}/debian/changelog | egrep '^Version:' | cut -f 2 -d ' '|cut -f 1 -d '-')
DEB_VER_GCC      := $(shell dpkg-parsechangelog -l/usr/src/gcc-${VER_GCC_BASE}/debian/changelog | egrep '^Version:' | cut -f 2 -d ' ')
VER_BINUTILS     := $(shell dpkg-parsechangelog -l/usr/src/binutils/debian/changelog | egrep '^Version:' | cut -f 2 -d ' '|cut -f 1 -d '-'|cut -d '.' -f1-3)
PKG_VER_BINUTILS := $(shell dpkg-parsechangelog -l/usr/src/binutils/debian/changelog | egrep '^Version:' | cut -f 2 -d ' '|cut -f 1 -d '-')
DEB_VER_BINUTILS := $(shell dpkg-parsechangelog -l/usr/src/binutils/debian/changelog | egrep '^Version:' | cut -f 2 -d ' ')
VER_GLIBC        := $(shell dpkg-parsechangelog -l/usr/src/glibc/debian/changelog | egrep '^Version:' | cut -f 2 -d ' '|cut -f 1 -d '-')
DEB_VER_GLIBC    := $(shell dpkg-parsechangelog -l/usr/src/glibc/debian/changelog | egrep '^Version:' | cut -f 2 -d ' ')

LINUX_BUILT_USING := linux (= $(DEB_VER_LINUX))
GLIBC_BUILT_USING := binutils (= $(DEB_VER_BINUTILS)), linux (= $(DEB_VER_LINUX)), gcc-$(VER_GCC_BASE) (= $(DEB_VER_GCC)), glibc (= $(DEB_VER_GLIBC))

control_vars = '-Vbu:linux=$(LINUX_BUILT_USING)' '-Vbu:glibc=$(GLIBC_BUILT_USING)'

CTB_LIBC_DEV_DEPENDS = linux-libc-dev (>= $(DEB_VER_LINUX))

BINUTILS_DIR  := /usr/src/binutils
GLIBC_DIR     := /usr/src/glibc
GCC_DIR       := /usr/src/gcc-${VER_GCC_BASE}

GLIBC_PATCHES  := $(CURDIR)/debian/patches/glibc/$(shell echo $(vendor) | tr A-Z a-z)

binutils_ldpath = $(shell if dpkg --compare-versions $(VER_BINUTILS) lt 2.25.51; \
			then echo $(CURDIR)/debian/tmp.${CROSS_ARCH}/usr/$(BUILD_GNU_TYPE)/${CROSS_GNU_TYPE}/lib; \
			else echo $(CURDIR)/debian/tmp.${CROSS_ARCH}/usr/lib/$(BUILD_GNU_TYPE); fi)

# taken from gcc packaging
define unpack_tarball
	tar -x -f $1
endef

info:
	@echo "Binutils version:         ${VER_BINUTILS}	${DEB_VER_BINUTILS}	${PKG_VER_BINUTILS}"
	@echo "GCC version:              ${VER_GCC}       	${DEB_VER_GCC}          ${VER_GCC_BASE}"
	@echo "Glibc version:            ${VER_GLIBC}  		${DEB_VER_GLIBC}"
	@echo "Linux version:            ${VER_LINUX}   	${DEB_VER_LINUX}"
	@echo
	@echo "Target architecture:      ${CROSS_ARCH}"
	@echo "Target GNU type:          ${CROSS_GNU_TYPE}"
	@echo "Host architecture:        ${HOST_ARCH}"
	@echo "Host GNU type:            ${HOST_GNU_TYPE}"
	@echo
	@echo "Built using information:"
	@echo '  linux: $(LINUX_BUILT_USING)'
	@echo '  glibc: $(GLIBC_BUILT_USING)'


$(stamp)init-dirs:
	mkdir -p $(foreach arch,$(CROSS_ARCHS),debian/tmp.$(arch))
	touch $@

init: $(stamp)init-linux

$(stamp)init-linux:
	@echo START $@
	$(call unpack_tarball, $(firstword $(wildcard /usr/src/linux-source-$(VER_LINUX).tar.* /usr/src/linux-source-$(VER_LINUX)/linux-source-$(VER_LINUX).tar.*)))
	touch $@

$(stamp)build-linux.%: $(stamp)init-linux
	@echo START $@
	cp debian/builddeb linux-source-$(VER_LINUX)/scripts/package/
	sed -i '/$$(MAKE)/d' linux-source-$(VER_LINUX)/scripts/package/Makefile
	set -e; \
	export DEBMAIL="`dpkg-parsechangelog |grep ^Maintainer | sed -e 's/^Maintainer: //g'`"; \
	export DEBEMAIL="`echo $$DEBMAIL | sed -e 's/.*<\(.*\)>/\1/g'`"; \
	export DEBFULLNAME="`echo $$DEBMAIL | sed -e 's/\(.*\)<.*>/\1/g'`"; \
	export ARCH=${KERNEL_ARCH} ;\
	export KBUILD_DEBARCH=${CROSS_ARCH} ;\
	export KDEB_PKGVERSION=${DEB_VER_LINUX} ;\
	cd linux-source-${VER_LINUX} ;\
	make oldnoconfig ;\
	make deb-pkg
	rm -rf tmp
	install -d tmp
	dpkg-deb -R linux-libc-dev-${CROSS_ARCH}-cross_${DEB_VER_LINUX}_all.deb debian/tmp.${CROSS_ARCH}
	dpkg-deb -R linux-libc-dev-${CROSS_ARCH}-cross_${DEB_VER_LINUX}_all.deb tmp
	cd tmp/usr/include ;\
	rm -rf drm scsi ;\
	rm -f `find . -name .install` ;\
	rm -f `find . -name ..install.cmd`
	mkdir tmp/usr/${CROSS_GNU_TYPE}
	mv tmp/usr/include/ tmp/usr/${CROSS_GNU_TYPE}/include/
	rm tmp/DEBIAN/md5sums
	install -d -m 755 tmp/usr/share/lintian/overrides
	echo "linux-libc-dev-${CROSS_ARCH}-cross binary: non-standard-dir-in-usr" \
	  >> tmp/usr/share/lintian/overrides/linux-libc-dev-${CROSS_ARCH}-cross
	fakeroot dpkg-deb -b tmp linux-libc-dev-${CROSS_ARCH}-cross_${DEB_VER_LINUX}_all.deb
	rm -rf tmp
	install -d tmp
	touch $@

$(stamp)install-linux.%: $(stamp)build-linux.% $(stamp)init-dirs
	@echo START $@
	dpkg-deb -x linux-libc-dev-${CROSS_ARCH}-cross_${DEB_VER_LINUX}_all.deb debian/linux-libc-dev-${CROSS_ARCH}-cross
	gunzip debian/linux-libc-dev-${CROSS_ARCH}-cross/usr/share/doc/linux-libc-dev-${CROSS_ARCH}-cross/changelog.Debian.gz
	mv debian/linux-libc-dev-${CROSS_ARCH}-cross/usr/share/doc/linux-libc-dev-${CROSS_ARCH}-cross/changelog.Debian \
	  debian/linux-libc-dev-${CROSS_ARCH}-cross/usr/share/doc/linux-libc-dev-${CROSS_ARCH}-cross/changelog.Debian.linux
	gzip -cn9 debian/linux-libc-dev-${CROSS_ARCH}-cross/usr/share/doc/linux-libc-dev-${CROSS_ARCH}-cross/changelog.Debian.linux \
	  > debian/linux-libc-dev-${CROSS_ARCH}-cross/usr/share/doc/linux-libc-dev-${CROSS_ARCH}-cross/changelog.Debian.linux.gz
	gzip -cn9 debian/changelog \
	  > debian/linux-libc-dev-${CROSS_ARCH}-cross/usr/share/doc/linux-libc-dev-${CROSS_ARCH}-cross/changelog.Debian.gz
	touch $@

define init_binutils
	$(call unpack_tarball, ${BINUTILS_DIR}/binutils-${VER_BINUTILS}.tar.xz)
	set -e; \
	cd binutils-${PKG_VER_BINUTILS} ;\
	cp -a ${BINUTILS_DIR}/debian/ . ;\
	if [ -n "$$(grep -v '^\#' ${CURDIR}/debian/patches/binutils/series)" ]; then \
	  QUILT_PATCHES=${CURDIR}/debian/patches/binutils quilt --quiltrc /dev/null  push -a; \
	fi; \
	rm -rf .pc
endef

$(stamp)init-binutils:
