## cross-toolchain-base 18

=== debian/changelog ===
cross-toolchain-base (18) unstable; urgency=medium

  * Fix build for i386 hosts. Closes: #860687.
  * Build using binutils 2.28-5.
  * Build using linux 4.9.25.
  * Build using gcc 6.3.0-18.

 -- Matthias Klose <doko@debian.org>  Mon, 15 May 2017 21:01:45 -0700
