=== debian/rules ===
--- 
+++ 
@@ -24,6 +24,7 @@
 HOST_ARCH        := $(shell dpkg-architecture -qDEB_HOST_ARCH_CPU)
 HOST_GNU_TYPE    := $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
 BUILD_GNU_TYPE   := $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
+BUILD_MULTIARCH  := $(shell dpkg-architecture -qDEB_BUILD_MULTIARCH)
 stamp            := stamp-dir/
 
 ifeq ($(vendor),Debian)
@@ -53,9 +54,9 @@
 endif
 
 MIN_VER_GLIBC		:= 2.24-8~
-MIN_VER_LINUX		:= 4.10
-MIN_VER_GCC		:= 6.3.0-3~
-MIN_VER_BINUTILS	:= 2.28-1~
+MIN_VER_LINUX		:= 4.9
+MIN_VER_GCC		:= 6.3.0-18~
+MIN_VER_BINUTILS	:= 2.28-5~
 
 DEB_VER_LINUX  := $(shell apt-cache policy linux-libc-dev | awk '/^ \*\*\*/ {print $$2}')
 ifeq ($(vendor),Ubuntu)
@@ -88,7 +89,7 @@
 
 binutils_ldpath = $(shell if dpkg --compare-versions $(VER_BINUTILS) lt 2.25.51; \
 			then echo $(CURDIR)/debian/tmp.${CROSS_ARCH}/usr/$(BUILD_GNU_TYPE)/${CROSS_GNU_TYPE}/lib; \
-			else echo $(CURDIR)/debian/tmp.${CROSS_ARCH}/usr/lib/$(BUILD_GNU_TYPE); fi)
+			else echo $(CURDIR)/debian/tmp.${CROSS_ARCH}/usr/lib/$(BUILD_MULTIARCH); fi)
 
 # taken from gcc packaging
 define unpack_tarball
@@ -173,9 +174,3 @@
 	cd binutils-${PKG_VER_BINUTILS} ;\
 	cp -a ${BINUTILS_DIR}/debian/ . ;\
 	if [ -n "$$(grep -v '^\#' ${CURDIR}/debian/patches/binutils/series)" ]; then \
-	  QUILT_PATCHES=${CURDIR}/debian/patches/binutils quilt --quiltrc /dev/null  push -a; \
-	fi; \
-	rm -rf .pc
-endef
-
-$(stamp)init-binutils:
