## cross-toolchain-base 25ubuntu6

=== debian/changelog ===
cross-toolchain-base (25ubuntu6) bionic; urgency=medium

  * Fix binutils installation in the build chroot.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 20 Apr 2018 08:14:33 +0200

cross-toolchain-base (25ubuntu5) bionic; urgency=medium

  * Build using gcc 7.3.0-16ubuntu3.
  * Build using glibc 2.27-3ubuntu1.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 19 Apr 2018 18:02:13 +0200

cross-toolchain-base (25ubuntu4) bionic; urgency=medium

  * Build using gcc 7.3.0-14ubuntu1.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 02 Apr 2018 22:30:51 +0200

cross-toolchain-base (25) unstable; urgency=medium

  * Add support for riscv64 (Aurelian Jarno). Addresses: #892790.
  * Build using gcc 7.3.0-14.
  * Build using binutils 2.30-11.
  * Fix dpkg-cross ldscript conversion for x32.
  * Add support to build packages for amd64, i386 and x32.
  * Build packages for amd64 and i386.

 -- Matthias Klose <doko@debian.org>  Mon, 02 Apr 2018 04:53:03 +0200

cross-toolchain-base (24) unstable; urgency=medium

  * Build using glibc 2.27. Closes: #886315.
  * Build using gcc 7.3.0-11.
  * Build using binutils 2.30-7.
  * Build using linux 4.15.

 -- Matthias Klose <doko@debian.org>  Mon, 12 Mar 2018 14:46:33 +0100

cross-toolchain-base (23ubuntu1) bionic; urgency=medium

  * Build using gcc 7.3.0-11ubuntu1.
  * Build powerpc binaries from this source (needed for ppc64el).

 -- Matthias Klose <doko@ubuntu.com>  Mon, 12 Mar 2018 12:54:10 +0100

cross-toolchain-base (23) unstable; urgency=medium

  * Build using glibc 2.27. Closes: #886315.
  * Build using gcc 7.3.0-11.
  * Build using binutils 2.30-7.
  * Build using linux 4.15.

 -- Matthias Klose <doko@debian.org>  Mon, 12 Mar 2018 11:50:44 +0100

cross-toolchain-base (22ubuntu2) bionic; urgency=medium

  * Update to build correctly against the new glibc 2.27-0ubuntuX:
    - Remove debian/patches/glibc/ubuntu/no-stack-protector.diff
    - Refresh debian/patches/glibc/ubuntu/local-kill-locales.patch
    - Drop unused debian/patches/glibc/ubuntu/cross-no-CXX.diff

 -- Adam Conrad <adconrad@ubuntu.com>  Thu, 22 Feb 2018 06:51:06 -0700

cross-toolchain-base (22ubuntu1) bionic; urgency=medium

  * Build using gcc 7.3.0-1ubuntu1.
  * Build using binutils 2.30.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 30 Jan 2018 19:09:47 +0100

cross-toolchain-base (22) unstable; urgency=medium

  * Build using glibc 2.26-2. Addresses: #886315.
  * Build using gcc 7.2.0-19.
  * Build using binutils 2.29.1-13.
  * Add support for ia64. Addresses: #886175.
  * dpkg-cross: Add fixes for mipsr6 and n32 (YunQiang Su). Addresses: #886312.

 -- Matthias Klose <doko@debian.org>  Sun, 07 Jan 2018 23:46:19 +0100

cross-toolchain-base (21) unstable; urgency=medium

  * Build using gcc 6.4.0-11.
  * Build using glibc 2.25-3.
  * Build using linux 4.14.2-1.
  * Build using binutils 2.29.1-10.
  * Update dpkg-cross for mips* targets. Closes: #883189.

 -- Matthias Klose <doko@debian.org>  Thu, 07 Dec 2017 07:59:56 +0100

cross-toolchain-base (20) unstable; urgency=medium

  * Build using gcc 6.4.0-10.
  * Build using glibc 2.25-1. Closes: #882168.
  * Build using linux 4.13.13-1.
  * Update build dependencies. Closes: #881618.
  * Add support for a plethora of mips r6 targets (YunQiang Su).
  * Update dpkg-cross. Addresses #881687.

 -- Matthias Klose <doko@debian.org>  Sun, 19 Nov 2017 23:02:17 +0100

cross-toolchain-base (19ubuntu1) artful; urgency=medium

  * Build using gcc 6.4.0-7ubuntu1.
  * Build using binutils 2.29.1.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 21 Sep 2017 08:55:32 +0200

cross-toolchain-base (19) unstable; urgency=medium

  * Build using binutils 2.29.1-1, using the standard debian targets.
  * Build using gcc 6.4.0-7.
  * Build using linux 4.12.13-1.
  * Build using glibc 2.24-17.

 -- Matthias Klose <doko@debian.org>  Wed, 20 Sep 2017 16:26:16 +0200

cross-toolchain-base (18ubuntu1) artful; urgency=medium

  * Build using gcc 6.4.
  * Build using glibc-2.29.
  * Build using linux 4.12.
  * Build using binutils 2.29.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 06 Sep 2017 11:48:17 +0200
