=== debian/rules ===
--- 
+++ 
@@ -1,4 +1,6 @@
 #!/usr/bin/make -f
+
+export SHELL = /bin/bash
 
 # prefix for builds - without leading slash
 PF ?= usr
@@ -32,18 +34,20 @@
 endif
 
 ifeq ($(DEB_NAME_ACT),cross-toolchain-base)
-  CROSS_ARCHS	?= s390x ppc64el arm64 armhf armel \
-			$(if $(filter $(vendor), Ubuntu),, mips mipsel mips64el)
+  CROSS_ARCHS	?= amd64 i386 s390x ppc64el arm64 armhf armel \
+			$(if $(filter $(vendor), Ubuntu), powerpc, mips mipsel mips64el)
 else
-  CROSS_ARCHS  ?= alpha hppa m68k mips64 powerpc ppc64 sh4 sparc64 \
-			$(if $(filter $(vendor), Ubuntu), mips mipsel mips64el) \
-			powerpcspe
+  CROSS_ARCHS  ?= alpha hppa m68k mips64 ppc64 riscv64 sh4 sparc64 x32 \
+			$(if $(filter $(vendor), Ubuntu), mips mipsel mips64el, powerpc) \
+			powerpcspe mipsn32 mipsn32el \
+			mipsr6 mipsr6el mipsn32r6 mipsn32r6el mips64r6 mips64r6el
 endif
 CROSS_ARCH       = $(subst .,,$(suffix $@))
 KERNEL_ARCH      = $(KERNEL_ARCH_$(CROSS_ARCH))
 CROSS_BIARCH     = $(CROSS_BIARCH_$(CROSS_ARCH))
 _gnu_type        = $(shell dpkg-architecture -a$(1) -qDEB_HOST_GNU_TYPE -f)
 CROSS_GNU_TYPE   = $(call _gnu_type,${CROSS_ARCH})
+CROSS_PKG_GNU_TYPE = $(subst _,-,$(call _gnu_type,${CROSS_ARCH}))
 
 # ARM32 soft-float/hard-float multilibs. These are not yet built in a
 # "proper" multilib location, so only build simple dependency packages
@@ -53,10 +57,10 @@
   ARM32_MULTILIBS := dummy
 endif
 
-MIN_VER_GLIBC		:= 2.24-8~
-MIN_VER_LINUX		:= 4.9
-MIN_VER_GCC		:= 6.3.0-18~
-MIN_VER_BINUTILS	:= 2.28-5~
+MIN_VER_GLIBC		:= 2.27-0~
+MIN_VER_LINUX		:= 4.15
+MIN_VER_GCC		:= 7.3.0-14~
+MIN_VER_BINUTILS	:= 2.30-11~
 
 DEB_VER_LINUX  := $(shell apt-cache policy linux-libc-dev | awk '/^ \*\*\*/ {print $$2}')
 ifeq ($(vendor),Ubuntu)
@@ -64,7 +68,7 @@
 else
   VER_LINUX      := $(shell echo $(DEB_VER_LINUX) | sed 's/^\([0-9]*\.[0-9]*\).*/\1/')
 endif
-VER_GCC_BASE   := 6
+VER_GCC_BASE   := 7
 
 VER_GCC          := $(shell dpkg-parsechangelog -l/usr/src/gcc-${VER_GCC_BASE}/debian/changelog | egrep '^Version:' | cut -f 2 -d ' '|cut -f 1 -d '-')
 DEB_VER_GCC      := $(shell dpkg-parsechangelog -l/usr/src/gcc-${VER_GCC_BASE}/debian/changelog | egrep '^Version:' | cut -f 2 -d ' ')
@@ -89,7 +93,11 @@
 
 binutils_ldpath = $(shell if dpkg --compare-versions $(VER_BINUTILS) lt 2.25.51; \
 			then echo $(CURDIR)/debian/tmp.${CROSS_ARCH}/usr/$(BUILD_GNU_TYPE)/${CROSS_GNU_TYPE}/lib; \
-			else echo $(CURDIR)/debian/tmp.${CROSS_ARCH}/usr/lib/$(BUILD_MULTIARCH); fi)
+			else echo $(CURDIR)/debian/tmp.${CROSS_ARCH}/usr/lib/$(BUILD_MULTIARCH)/binutils; fi)
+
+# FIXME: No conflict for the host == cross case ...
+BINUTILS_BUILD_CONFLICTS = $(foreach a,$(CROSS_ARCHS),$(if $(filter amd64,$(a)),,binutils-$(subst _,-,$(call _gnu_type,$(a)))$(,)))
+GLIBC_BUILD_CONFLICTS = $(foreach a,$(CROSS_ARCHS),libc6-$(a)-cross$(,) linux-libc-dev-$(a)-cross$(,))
 
 # taken from gcc packaging
 define unpack_tarball
@@ -163,14 +171,3 @@
 	mv debian/linux-libc-dev-${CROSS_ARCH}-cross/usr/share/doc/linux-libc-dev-${CROSS_ARCH}-cross/changelog.Debian \
 	  debian/linux-libc-dev-${CROSS_ARCH}-cross/usr/share/doc/linux-libc-dev-${CROSS_ARCH}-cross/changelog.Debian.linux
 	gzip -cn9 debian/linux-libc-dev-${CROSS_ARCH}-cross/usr/share/doc/linux-libc-dev-${CROSS_ARCH}-cross/changelog.Debian.linux \
-	  > debian/linux-libc-dev-${CROSS_ARCH}-cross/usr/share/doc/linux-libc-dev-${CROSS_ARCH}-cross/changelog.Debian.linux.gz
-	gzip -cn9 debian/changelog \
-	  > debian/linux-libc-dev-${CROSS_ARCH}-cross/usr/share/doc/linux-libc-dev-${CROSS_ARCH}-cross/changelog.Debian.gz
-	touch $@
-
-define init_binutils
-	$(call unpack_tarball, ${BINUTILS_DIR}/binutils-${VER_BINUTILS}.tar.xz)
-	set -e; \
-	cd binutils-${PKG_VER_BINUTILS} ;\
-	cp -a ${BINUTILS_DIR}/debian/ . ;\
-	if [ -n "$$(grep -v '^\#' ${CURDIR}/debian/patches/binutils/series)" ]; then \
